<?php

// 
// 1.00 Original release
//

/* Name this file get_xml_inventory.php or whatever you want, just change it in the cron job below also.
   This program must reside in your admin directory! If you want it elsewhere you will have to hard code the paths below

   Use the following cron job to execute this. Edit the absolute path to your admin directory.
   
               php /absolute/path/to/shop/admin/get_xml_inventory.php
               
*/

// have to include the admin configure file
  require('includes/configure.php');

// set options

// Set mode of operation                                     // use for setting test mode or live mode.
$test_mode = 1;                                               // 1 = test mode,  0 = live mode

// file and directory names - must be absolute paths and not URLs
$working_dir = DIR_FS_ADMIN;                      // Uses admin directory from configure.php file
$local_file = DIR_FS_ADMIN . 'products.xml';      // Uses admin directoy / local and temp file name where you will store the file on your server
$temp_file = DIR_FS_ADMIN . 'inventory.tmp';      // It will run cleaner if you create these files manually beforehand.

// this is the method you will use to get your data feed
$get_method = 'off';                                         // valid values are 'ftp' or 'http' or 'off'   NOTE that http method uses curl and so will not work under xampp
                                                             // Off is useful for testing or when a supplier 'puts' a file on your server instead of you having to go out and get it
                                                             
// these are required if you use ftp as your get method
$ftp_server = 'ftp://domain.com';                            // Change to fully qualified domain name
$ftp_user_name = 'your_user_name';                           // Change to your user name
$ftp_user_passs = 'password';                                // Change to your password
$remote_dir = '' ;                                           // Change to something other than entry directory
$remote_file = 'products.csv';                               // name of products file to get from vendor

// this is required is you use the http get method. It should be a valid URL that you get get with a browser
$url_to_file = 'http://....URL to xml file from supplier';                            // If http is Get_method this must be a valid URL to the file 

// These are general options
$use_map = 0;                                                // set to 1 to enable map
$use_markup = 0;                                             //set to 1 to enable getting the markup % from the category record
$markup = 0.0;													// the markup % to be used default is set to zero %
$roundto ='';
/* Set your common field, normally this does not need to be changed.
   For this to work your data feed must have a unique field (like products_id or products_model) that matches one for one with a field in
   your database. 
*/

define('PRODUCT_ID', 'products_model');                    // default is 'products_model' Change to whatever your common field is

// //////////////// There are three additional edits below. See line 124, 162 and 179 /////////////////////////////

// Let's change to the working directory
chdir($working_dir);                                          // this does not work under xampp so just comment it out

// Start the download
switch ($get_method) {
case "off":
break;
case "ftp":

// open some file to write to.
$handle = fopen($local_file, 'w');

// set up basic connection
$conn_id = ftp_connect($ftp_server);

// login with username and password
$login_result = ftp_login($conn_id, $ftp_user_name, $ftp_user_pass);

// change directory if need to
if (isset($remote_dir)) {
ftp_chdir($conn_id, $remote_dir);
}

// try to download $remote_file and save it to $handle
if (ftp_fget($conn_id, $handle, $remote_file, FTP_ASCII, 0)) {
 echo "successfully written to $local_file\n";                                // may have to comment this out after testing
} else {
 echo "There was a problem while downloading $remote_file to $local_file\n";  // may have to comment this out after testing
}

// close the connection and the file handle
ftp_close($conn_id);
fclose($handle);

// end of php-ftp code
break;
case "http":
default:
// following uses curl as php code
$ch = curl_init($url_to_file);
$fp = fopen($local_file, "w");

curl_setopt($ch, CURLOPT_FILE, $fp);
curl_setopt($ch, CURLOPT_HEADER, 0);

curl_exec($ch);
curl_close($ch);
fclose($fp);
// end of php-curl code
}

// let's get the database open now
// include the database functions
  require('includes/functions/database.php');

// make a connection to the database... now
  tep_db_connect() or die('Unable to connect to database server!');

// open the xml file and build structure
$handle = @fopen($local_file,"r");
// open tmp file for writing
$tmp_handle = @fopen($temp_file,"w");

if ($handle) {
   while (!feof($handle)){
      $buffer = fgets($handle,4096);

// ************************** Possible edit needed here **************************************      
// sanitize garbage delivered by supplier into valid XML file, if necessary. Populate and uncomment as necessary
    $buffer = str_replace('&lt;','<',$buffer);
    $buffer = str_replace('&gt;','>',$buffer);
//    $buffer = str_replace('','',$buffer);
//    $buffer = str_replace('','',$buffer);
//    $buffer = str_replace('','',$buffer);
//    $buffer = str_replace('','',$buffer);
// *******************************************************************************
    if($buffer) {
      fwrite($tmp_handle,$buffer);
      }
    }
  }
// complete repairing xml file

// initialize some variables
    $name = '';
    $value = '';
    
// create new reader and open file
    $xml = new XMLReader();
    $xml->open($temp_file);

// read each line of the file
while ($xml->read()){
// echo $xml->nodeType . "<BR>\n";   // debug

// assign element node name to $name
   if ($xml->nodeType == XMLreader::ELEMENT) {
      $name = $xml->name;
    }

// assign element value to $value    
    if (in_array($xml->nodeType, array(XMLReader::TEXT, XMLReader::CDATA, XMLReader::WHITESPACE, XMLReader::SIGNIFICANT_WHITESPACE)) && $name!=''){
        $value= $xml->value;
    }

// ************************************* This block needs to be edited to match your xml file. ONLY THE NAMES IN CAPS NEED TO BE CHANGED *************
// assign each value to specific variables
     if ($name == "SKU") $model_no = trim($value);     // this may match your products_id or it may match your products_model or a custome field.
     if ($name == "Price")   $cost = trim($value);
     if ($name == "Count")  $qty = trim($value);
//     if ($name == "MFGINO") $model = trim($value);   // this may or may not be necessary. The others are necessary.
// **********************************************************
// ends getting data and populating local variables

//reset name/value values
  if ($xml->nodeType == XMLReader::END_ELEMENT){
    $name = '';
    $value = '';
  }

// **************************** This (name == 'Table') needs to be changed to the nametag that surrounds each produt. ************************
// only continue if we reach the product end tag
    if ($xml->nodeType == XMLReader::END_ELEMENT && $xml->name == 'vwGSInvCounts'){
 
if ($use_markup == true) {       // requires a markup column in the categories table with markeup amount as decimal ( .20 as 20%)
	// get and set markup
	$sql = "select categories.markup from categories,products_to_categories,products where products.products_model = '" . $model_no . "' and products.products_id = products_to_categories.products_id and products_to_categories.categories_id = categories.categories_id";
	$result = mysql_query($sql);
	$markupres = mysql_fetch_row($result);
	$markup = $markupres[0];
}

if ($roundto == '') {
	$price = $cost * (1+$markup);
} else {
	$price = (int)($cost * (1+$markup))+ $roundto;
}

if ($use_map == true) {	// are we going to use MAP pricing?       Requires a products_map column in the products table, with a value for map, NULL if no MAP
	$sql = "select products_map from products where " . PRODUCT_ID . "= '" . $model_no . "'";
	$result = mysql_query($sql);
	$map = mysql_fetch_row($result);

	if (!(is_null($map[0]))) {
		$cost = $map[0];
	}
}

if ($test_mode == true) {
   echo "<table border=1>";
   echo " <tr>";
   echo "  <td>" . $model_no . "</td><td>" . $cost . "</td><td>" . $price . "</td><td>" . $qty . "</td>";
   echo " </tr>";
   echo "</table>"; 
  } else {
	// OK, let's build and execute the sql statement for this item    
	$sql = "update products set products_quantity = '" . $qty . "', products_price = '" . $price . "' where " . PRODUCT_ID . "= '" . $model_no . "'";
	$result = mysql_query($sql);      // this executes the sql
  }
 } 
}                                   // back up to process next item

// and finally, close the db and we are done.
tep_db_close();

?>